SystemOrganization addCategory: #'Seaside-Pharo-Tools-Spec'!

!GRPackage class methodsFor: '*seaside-pharo-tools-spec' stamp: 'pmm 9/16/2013 10:37'!
seasidePharoToolsSpec
	^ self new
		name: 'Seaside-Pharo-Tools-Spec';
		description: 'Spec based server adapter browser for Pharo';
		addDependency: 'Seaside-Tools-Core';
		url: #seasideUrl;
		yourself! !

!ThemeIcons methodsFor: '*seaside-pharo-tools-spec' stamp: 'JohanBrichau 6/14/2014 09:15'!
seasideAdaptorRunningIcon 
	^ icons
			at: #'seasideAdaptorRunningIcon'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self seasideAdaptorRunningIconContents readStream) ].! !

!ThemeIcons methodsFor: '*seaside-pharo-tools-spec' stamp: 'JohanBrichau 6/14/2014 09:25'!
seasideAdaptorRunningIconContents
	"Private - Method generated"
	^ 'iVBORw0KGgoAAAANSUhEUgAAAAwAAAAMCAYAAABWdVznAAAKQWlDQ1BJQ0MgUHJvZmlsZQAA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'! !

!ThemeIcons methodsFor: '*seaside-pharo-tools-spec' stamp: 'JohanBrichau 6/14/2014 09:15'!
seasideAdaptorStoppedIcon 
	^ icons
			at: #'seasideAdaptorStoppedIcon'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self seasideAdaptorStoppedIconContents readStream) ].! !

!ThemeIcons methodsFor: '*seaside-pharo-tools-spec' stamp: 'JohanBrichau 6/14/2014 09:39'!
seasideAdaptorStoppedIconContents
	"Private - Method generated"
	^ 'iVBORw0KGgoAAAANSUhEUgAAAAwAAAAMCAIAAADZF8uwAAAKQWlDQ1BJQ0MgUHJvZmlsZQAA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'! !

Object subclass: #WAPharoToolsIcons
	instanceVariableNames: ''
	classVariableNames: 'Icons Instance'
	poolDictionaries: ''
	category: 'Seaside-Pharo-Tools-Spec'!

!WAPharoToolsIcons class methodsFor: 'accessing' stamp: 'StephanEggermont 8/31/2012 17:46'!
default
	^ Instance ifNil: [ Instance := self new ]! !

!WAPharoToolsIcons class methodsFor: 'private' stamp: 'StephanEggermont 8/31/2012 17:46'!
findIcon: aSymbol
	(self canUnderstand: aSymbol)
		ifTrue: [ ^ self default perform: aSymbol ].
	^ UITheme current
		iconNamed: ('small' , aSymbol capitalized) asSymbol
		ifNone: [ UITheme current iconNamed: aSymbol ]! !

!WAPharoToolsIcons class methodsFor: 'accessing' stamp: 'StephanEggermont 8/31/2012 17:46'!
iconNamed: aSymbol
	^ Icons at: aSymbol ifAbsentPut: [ self findIcon: aSymbol ]! !

!WAPharoToolsIcons class methodsFor: 'initialization' stamp: 'StephanEggermont 8/31/2012 17:46'!
initialize
	Instance := nil.
	Icons := IdentityDictionary new! !

ComposableModel subclass: #WAPharoServerAdapterSpecBrowser
	instanceVariableNames: 'listModel textModel toolbarModel adaptor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Pharo-Tools-Spec'!

!WAPharoServerAdapterSpecBrowser commentStamp: '<historical>' prior: 0!
WAPharoServerAdapterSpecBrowser example!

!WAPharoServerAdapterSpecBrowser class methodsFor: 'specs' stamp: 'JohanBrichau 2/7/2014 09:47'!
defaultSpec
	<spec>
	| delta |
	delta := 15.
	^ SpecLayout composed 
			add: #listModel origin: 0@0 corner: 1@0.5 offsetOrigin: 0@0 offsetCorner: 0@(delta negated);
			add: #toolbarModel origin: 0@0.5 corner: 1@0.5 offsetOrigin: 0@(delta negated) offsetCorner: 0@delta;
			add: #textModel origin: 0@0.5 corner: 1@1 offsetOrigin: 0@delta offsetCorner: 0@0;
			yourself! !

!WAPharoServerAdapterSpecBrowser class methodsFor: 'specs' stamp: 'JohanBrichau 6/14/2014 09:17'!
menuCommandOn: aBuilder
	<worldMenu>

	(aBuilder item: #ServerAdapterBrowser)
		order: 0.21;
		parent: #Tools;
		label: 'Seaside Control Panel';
		icon: (Smalltalk ui icons iconNamed: #seasideAdaptorRunningIcon);
		action: [ WAPharoServerAdapterSpecBrowser open ]! !

!WAPharoServerAdapterSpecBrowser class methodsFor: 'example' stamp: 'pmm 9/13/2013 15:23'!
open
	"self open"
	WAPharoServerAdapterSpecBrowser new openWithSpec
! !

!WAPharoServerAdapterSpecBrowser class methodsFor: 'specs' stamp: 'StephanEggermont 8/31/2012 14:50'!
title
	^'Seaside Control Panel'! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'private' stamp: 'StephanEggermont 8/31/2012 16:50'!
adapters: aList
	self listModel items: aList! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'accessing' stamp: 'pmm 9/13/2013 15:11'!
adaptor
	^ adaptor! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'private' stamp: 'JohanBrichau 6/18/2014 20:44'!
adaptorClasses
	^ (WAServerAdaptor allSubclasses reject: [ :each | each isAbstract ])
		asSortedCollection: [ :a :b | a name < b name ]! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'accessing' stamp: 'JohanBrichau 6/18/2014 21:12'!
adaptorsMenu: aMenu 
	^ aMenu
		addGroup: [ :group | 
			group addItem: [ :item |
				item 
					name: 'Add adaptor';
					action: [ self addAdaptor ] ].
			group addItem: [ :item |
				item 
					name: 'Remove adaptor';
					action: [ self removeAdaptor: self listModel selectedItem ] ] ];
		addGroup: [ :group | 
			group addItem: [ :item |
				item 
					name: 'Set encoding';
					action: [ self setEncodingFor: self listModel selectedItem ] ] ];
		addGroup: [ :group | 
			group addItem: [ :item |
				item 
					name: 'Clear configuration caches';
					action: [ self clearConfigurationCaches ] ].
			group addItem: [ :item |
				item 
					name: 'Clear sessions';
					action: [ self clearSessions ] ] ].! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'actions' stamp: 'JohanBrichau 6/18/2014 20:58'!
addAdaptor
	|allAdaptors class port |
	allAdaptors := self adaptorClasses.
	class := UIManager default
		chooseFrom: (allAdaptors collect: [:e | e name])
		values: allAdaptors
		lines: #()
		title: 'Add Seaside Adaptor' translated.
	port := UIManager default
		request: 'Enter a port number' 
		initialAnswer: class basicNew defaultPort greaseString.
	(port isNil or: [ port isEmpty or: [ port isAllDigits not ] ]) ifTrue: [ ^ self ].
	adaptor := class port: port greaseInteger.
	self initializeAdaptors! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'actions' stamp: 'JohanBrichau 6/18/2014 21:10'!
clearConfigurationCaches
	WAAdmin clearConfigurationCaches! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'actions' stamp: 'JohanBrichau 6/18/2014 21:10'!
clearSessions
	WAAdmin clearSessions! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'private' stamp: 'JohanBrichau 6/18/2014 21:03'!
codecs
	^ GRCodec allCodecs asSortedCollection: [ :a :b | a name < b name ]! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'private' stamp: 'pmm 9/13/2013 15:03'!
disableAllButtons

	self toolbarModel startButton enabled: false.
	self toolbarModel stopButton enabled: false.
	self toolbarModel browseButton enabled: false! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/13/2013 14:49'!
enableBrowseButton

	self toolbarModel browseButton enabled: true! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/13/2013 14:49'!
enableStartButton

	self toolbarModel startButton enabled: true! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/13/2013 14:49'!
enableStopButton

	self toolbarModel stopButton enabled: true! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'initialization' stamp: 'JohanBrichau 6/18/2014 20:56'!
initializeAdaptors
	self adapters: WAServerManager default adaptors! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'initialization' stamp: 'JohanBrichau 6/18/2014 21:06'!
initializePresenter

	self initializeAdaptors.
	
	listModel whenSelectedItemChanged: [ :selection |
		adaptor := selection.
		self disableAllButtons.
		selection isNil
			ifTrue: [
				textModel text: ''.
				textModel behavior: nil ]
	             ifFalse: [ 
				adaptor canStart
					ifTrue: [ self enableStartButton ].
				adaptor canStop
					ifTrue: [ self enableStopButton	 ].
				self enableBrowseButton.
				textModel text: (String streamContents: [ :stream |
			stream 
				nextPutAll: 'Type: '; nextPutAll: adaptor class name; nextPut: Character cr;
				nextPutAll: 'Port: '; nextPutAll: adaptor port greaseString; nextPut: Character cr;
				nextPutAll: 'Encoding: '; nextPutAll: adaptor codec name; nextPut: Character cr.
			adaptor additionalStatusOn: stream.
			stream
				nextPutAll: adaptor statusString ]) ]]
! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'initialization' stamp: 'JohanBrichau 6/14/2014 10:52'!
initializeWidgets

	self instantiateModels: #(
		listModel NewListModel
		textModel TextModel
		toolbarModel WAServerAdapterToolbar).
	
	self focusOrder
		add: listModel;
		add: toolbarModel;
		add: textModel.
	
	textModel aboutToStyle: false.
	listModel displayBlock: [ :item | item class name,' ',item statusString ].
	listModel menu: [ :aMenu | self adaptorsMenu: aMenu].
	
	self disableAllButtons! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'accessing' stamp: 'pmm 9/13/2013 15:19'!
listModel
	^ listModel! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'actions' stamp: 'JohanBrichau 6/18/2014 20:58'!
removeAdaptor: anAdaptor
	anAdaptor isStopped ifTrue:[anAdaptor unregister].
	self initializeAdaptors! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'actions' stamp: 'JohanBrichau 6/18/2014 21:13'!
setEncodingFor: anAdaptor
	| codec |
	codec := UIManager default
		chooseFrom: (self codecs collect: [ :each | each name ]) 
		values: self codecs
		lines: #()
		title: 'Select encoding' translated.
	codec isNil
		ifTrue: [ ^ self ].
	anAdaptor codec: codec.! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'accessing' stamp: 'pmm 9/13/2013 15:20'!
textModel
	^ textModel! !

!WAPharoServerAdapterSpecBrowser methodsFor: 'accessing' stamp: 'pmm 9/13/2013 15:20'!
toolbarModel
	^ toolbarModel! !

ComposableModel subclass: #WAServerAdapterToolbar
	instanceVariableNames: 'startButton stopButton browseButton startAction stopAction browseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Pharo-Tools-Spec'!

!WAServerAdapterToolbar class methodsFor: 'specs' stamp: 'JohanBrichau 2/7/2014 09:53'!
defaultSpec

	<spec>
	^ SpecLayout composed
		newRow: [ :row | 
			row
				add: #(model startButton);
				add: #(model stopButton);
				add: #(model browseButton) ];
		yourself! !

!WAServerAdapterToolbar class methodsFor: 'specs' stamp: 'StephanEggermont 8/31/2012 16:20'!
title
	^'Server adapter toolbar'! !

!WAServerAdapterToolbar methodsFor: 'actions' stamp: 'pmm 9/13/2013 15:17'!
browseAdaptor

	self owner adaptor ifNotNilDo: [ :adaptor |
		adaptor inspect ]! !

!WAServerAdapterToolbar methodsFor: 'accessing' stamp: 'StephanEggermont 8/31/2012 16:26'!
browseButton
	^browseButton! !

!WAServerAdapterToolbar methodsFor: 'initialization' stamp: 'StephanEggermont 8/31/2012 16:12'!
initialize
	super initialize.
	startAction := [true] asValueHolder.
	stopAction := [true] asValueHolder.
	browseAction := [true] asValueHolder.! !

!WAServerAdapterToolbar methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 9/13/2013 14:50'!
initializeWidgets

	self instantiateModels: #(
		startButton ButtonModel
		stopButton ButtonModel
		browseButton ButtonModel).
	
	self registerStartButtonEvents.
	self registerStopButtonEvents.
	self registerBrowseButtonEvents.
	
	self focusOrder 
		add: startButton;
		add: stopButton;
		add: browseButton.
	! !

!WAServerAdapterToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/13/2013 14:51'!
registerBrowseButtonEvents

	browseButton 
		label: 'Browse';
		enabled: true;
		action: [ self browseAdaptor ];
		state: false! !

!WAServerAdapterToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/13/2013 14:51'!
registerStartButtonEvents

	startButton 
		label: 'Start';
		enabled: true;
		action: [ self startAdaptor ];
		state: false! !

!WAServerAdapterToolbar methodsFor: 'private' stamp: 'BenjaminVanRyseghem 9/13/2013 14:51'!
registerStopButtonEvents

	stopButton 
		label: 'Stop';
		enabled: true;
		action: [ self stopAdaptor ];
		state: false! !

!WAServerAdapterToolbar methodsFor: 'actions' stamp: 'pmm 9/13/2013 15:12'!
startAdaptor

	self owner adaptor ifNotNilDo: [ :adaptor |
		adaptor start ]! !

!WAServerAdapterToolbar methodsFor: 'accessing' stamp: 'StephanEggermont 8/31/2012 16:26'!
startButton
	^startButton! !

!WAServerAdapterToolbar methodsFor: 'actions' stamp: 'pmm 9/13/2013 15:12'!
stopAdaptor

	self owner adaptor ifNotNilDo: [ :adaptor |
		adaptor stop ]! !

!WAServerAdapterToolbar methodsFor: 'accessing' stamp: 'StephanEggermont 8/31/2012 16:26'!
stopButton
	^stopButton! !
WAPharoToolsIcons initialize!
